#"A Nonparametric Statistical Approach to Content Analysis of Items"
#Stats

#Diego Marcondes and Nilton Rogerio Marcondes
#Instituto de Matemática e Estatística, Universidade de São Paulo, Brasil
#Tel.: +55 11 97585-6644
#dmarcondes@ime.usp.br

####SIMULATION STUDIES#####

source("Cochran.test.R")

#NUMBER OF DIMENSIONS, ITEMS AND SPECIALISTS
dimension <- 3
items <- 30
specialists <- 9

#SCENARIO 1
p <- 0.9
pvalue <- vector()
nItems <- vector()
pb <- txtProgressBar(min = 0,max = 50000,initial = 0,style = 3)
set.seed(100)
for(sim in 1:50000){
  setTxtProgressBar(pb,sim)
  m <- matrix(nrow = items,ncol = specialists)
  for(j in 1:specialists)
    for(i in 1:items){
      if(j == 1)
        m[i,j] <- sample(x = c(1:dimension),size = 1,replace = FALSE,prob = c(0.45,rep((1 - 0.45)/(dimension - 1),dimension-1)))
      else
        m[i,j] <- sample(x = c(1:dimension),size = 1,replace = FALSE,prob = c(p,rep((1 - p)/(dimension - 1),dimension-1)))
    }
  Q <- cochranQ(m,0.5)
  pvalue[sim] <- Q$pvalue
  nItems[sim] <- Q$items
}
mean1 <- mean(nItems)
power1 <- sum(pvalue <= 0.05)/50000

#SCENARIO 2
p <- 0.9
pvalue <- vector()
nItems <- vector()
pb <- txtProgressBar(min = 0,max = 50000,initial = 0,style = 3)
set.seed(100)
for(sim in 1:50000){
  setTxtProgressBar(pb,sim)
  m <- matrix(nrow = items,ncol = specialists)
  for(j in 1:specialists)
    for(i in 1:items){
      if(j %in% c(1,2,3))
        m[i,j] <- sample(x = c(1:dimension),size = 1,replace = FALSE,prob = c(0.45,rep((1 - 0.45)/(dimension - 1),dimension-1)))
      else
        m[i,j] <- sample(x = c(1:dimension),size = 1,replace = FALSE,prob = c(p,rep((1 - p)/(dimension - 1),dimension-1)))
    }
  Q <- cochranQ(m,0.5)
  pvalue[sim] <- Q$pvalue
  nItems[sim] <- Q$items
}
mean2 <- mean(nItems)
power2 <- sum(pvalue <= 0.05)/50000

#SCENARIO 3
p <- 0.9
pvalue <- vector()
nItems <- vector()
pb <- txtProgressBar(min = 0,max = 50000,initial = 0,style = 3)
set.seed(100)
for(sim in 1:50000){
  setTxtProgressBar(pb,sim)
  m <- matrix(nrow = items,ncol = specialists)
  for(j in 1:specialists)
    for(i in 1:items){
      if(j == 1)
        m[i,j] <- sample(x = c(1:dimension),size = 1,replace = FALSE,prob = c(45,rep((1 - 0.45)/(dimension - 1),dimension-1)))
      else if(j == 2)
        m[i,j] <- sample(x = c(1:dimension),size = 1,replace = FALSE,prob = c(0.35,rep((1 - 0.35)/(dimension - 1),dimension-1)))
      else if(j == 3)
        m[i,j] <- sample(x = c(1:dimension),size = 1,replace = FALSE,prob = c(0.25,rep((1 - 0.25)/(dimension - 1),dimension-1)))
      else
        m[i,j] <- sample(x = c(1:dimension),size = 1,replace = FALSE,prob = c(p,rep((1 - p)/(dimension - 1),dimension-1)))
    }
  Q <- cochranQ(m,0.5)
  pvalue[sim] <- Q$pvalue
  nItems[sim] <- Q$items
}
mean3 <- mean(nItems)
power3 <- sum(pvalue <= 0.05)/50000

#SCENARIO 4
p <- 0.9
pvalue <- vector()
nItems <- vector()
pb <- txtProgressBar(min = 0,max = 50000,initial = 0,style = 3)
set.seed(100)
for(sim in 1:50000){
  setTxtProgressBar(pb,sim)
  m <- matrix(nrow = items,ncol = specialists)
  for(j in 1:specialists)
    for(i in 1:items){
      if(j == 1)
        m[i,j] <- sample(x = c(1:dimension),size = 1,replace = FALSE,prob = c(0.8,rep((1 - 0.8)/(dimension - 1),dimension-1)))
      else
        m[i,j] <- sample(x = c(1:dimension),size = 1,replace = FALSE,prob = c(p,rep((1 - p)/(dimension - 1),dimension-1)))
    }
  Q <- cochranQ(m,0.5)
  pvalue[sim] <- Q$pvalue
  nItems[sim] <- Q$items
}
mean4 <- mean(nItems)
power4 <- sum(pvalue <= 0.05)/50000

#SCENARIO 5
p <- 0.9
pvalue <- vector()
nItems <- vector()
pb <- txtProgressBar(min = 0,max = 50000,initial = 0,style = 3)
set.seed(100)
for(sim in 1:50000){
  setTxtProgressBar(pb,sim)
  m <- matrix(nrow = items,ncol = specialists)
  for(j in 1:specialists)
    for(i in 1:items){
      if(j %in% c(1,2))
        m[i,j] <- sample(x = c(1:dimension),size = 1,replace = FALSE,prob = c(0.8,rep((1 - 0.8)/(dimension - 1),dimension-1)))
      else
        m[i,j] <- sample(x = c(1:dimension),size = 1,replace = FALSE,prob = c(p,rep((1 - p)/(dimension - 1),dimension-1)))
    }
  Q <- cochranQ(m,0.5)
  pvalue[sim] <- Q$pvalue
  nItems[sim] <- Q$items
}
mean5 <- mean(nItems)
power5 <- sum(pvalue <= 0.05)/50000

#SCENARIO 6
p <- 0.6
pvalue <- vector()
nItems <- vector()
pb <- txtProgressBar(min = 0,max = 50000,initial = 0,style = 3)
set.seed(100)
for(sim in 1:50000){
  setTxtProgressBar(pb,sim)
  m <- matrix(nrow = items,ncol = specialists)
  for(j in 1:specialists)
    for(i in 1:items){
      if(j %in% c(1,2,3))
        m[i,j] <- sample(x = c(1:dimension),size = 1,replace = FALSE,prob = c(0.75,rep((1 - 0.75)/(dimension - 1),dimension-1)))
      else
        m[i,j] <- sample(x = c(1:dimension),size = 1,replace = FALSE,prob = c(p,rep((1 - p)/(dimension - 1),dimension-1)))
    }
  Q <- cochranQ(m,0.5)
  pvalue[sim] <- Q$pvalue
  nItems[sim] <- Q$items
}
mean6 <- mean(nItems)
power6 <- sum(pvalue <= 0.05)/50000

#SCENARIO 7
p <- 0.3
pvalue <- vector()
nItems <- vector()
pb <- txtProgressBar(min = 0,max = 50000,initial = 0,style = 3)
set.seed(100)
for(sim in 1:50000){
  setTxtProgressBar(pb,sim)
  m <- matrix(nrow = items,ncol = specialists)
  for(j in 1:specialists)
    for(i in 1:items){
      if(j %in% c(1,2,3))
        m[i,j] <- sample(x = c(1:dimension),size = 1,replace = FALSE,prob = c(0.75,rep((1 - 0.75)/(dimension - 1),dimension-1)))
      else
        m[i,j] <- sample(x = c(1:dimension),size = 1,replace = FALSE,prob = c(p,rep((1 - p)/(dimension - 1),dimension-1)))
    }
  Q <- cochranQ(m,0.5)
  pvalue[sim] <- Q$pvalue
  nItems[sim] <- Q$items
}
mean7 <- mean(nItems)
power7 <- sum(pvalue <= 0.05)/50000

#SCENARIO 8
p <- c(0.1,0.2,0.3,0.4,0.5,0.6,0.7,0.8,0.90)
pvalue <- vector()
nitems <- vector()
pb <- txtProgressBar(min = 0,max = 50000,initial = 0,style = 3)
set.seed(100)
for(sim in 1:50000){
  setTxtProgressBar(pb,sim)
  m <- matrix(nrow = items,ncol = specialists)
  for(j in 1:specialists)
    for(i in 1:items){
      m[i,j] <- sample(x = c(1:dimension),size = 1,replace = FALSE,prob = c(p[j],rep((1 -p[j])/(dimension - 1),dimension-1)))
    }
  Q <- cochranQ(m,0.5)
  pvalue[sim] <- Q$pvalue
  nItems[sim] <- Q$items
}
mean8 <- mean(nItems)
power8 <- sum(pvalue <= 0.05)/50000

#SCENARIO 9
p <- list()
nItems <- vector()
set.seed(100)
w <- runif(9,0,0.1)
p[[1]] <- c(0.9,w[1],0.1-w[1])
p[[2]] <- c(0.9,w[2],0.1-w[2])
p[[3]] <- c(0.9,w[3],0.1-w[3])
p[[4]] <- c(0.9,w[4],0.1-w[4])
p[[5]] <- c(0.9,w[5],0.1-w[5])
p[[6]] <- c(0.9,w[6],0.1-w[6])
p[[7]] <- c(0.9,w[7],0.1-w[7])
p[[8]] <- c(0.9,w[8],0.1-w[8])
p[[9]] <- c(0.9,w[9],0.1-w[9])
pvalue <- vector()
pb <- txtProgressBar(min = 0,max = 50000,initial = 0,style = 3)
set.seed(100)
for(sim in 1:50000){
  setTxtProgressBar(pb,sim)
  m <- matrix(nrow = items,ncol = specialists)
  for(j in 1:specialists)
    for(i in 1:items){
      m[i,j] <- sample(x = c(1:dimension),size = 1,replace = FALSE,prob = p[[j]])
    }
  Q <- cochranQ(m,0.5)
  pvalue[sim] <- Q$pvalue
  nItems[sim] <- Q$items
}
mean9 <- mean(nItems)
power9 <- sum(pvalue <= 0.05)/50000

#SCENARIO 10
p <- list()
nItems <- vector()
set.seed(100)
w <- runif(9,0,0.4)
p[[1]] <- c(0.6,w[1],0.4-w[1])
p[[2]] <- c(0.6,w[2],0.4-w[2])
p[[3]] <- c(0.6,w[3],0.4-w[3])
p[[4]] <- c(0.6,w[4],0.4-w[4])
p[[5]] <- c(0.6,w[5],0.4-w[5])
p[[6]] <- c(0.6,w[6],0.4-w[6])
p[[7]] <- c(0.6,w[7],0.4-w[7])
p[[8]] <- c(0.6,w[8],0.4-w[8])
p[[9]] <- c(0.6,w[9],0.4-w[9])
pvalue <- vector()
pb <- txtProgressBar(min = 0,max = 50000,initial = 0,style = 3)
set.seed(100)
for(sim in 1:50000){
  setTxtProgressBar(pb,sim)
  m <- matrix(nrow = items,ncol = specialists)
  for(j in 1:specialists)
    for(i in 1:items){
      m[i,j] <- sample(x = c(1:dimension),size = 1,replace = FALSE,prob = p[[j]])
    }
  Q <- cochranQ(m,0.5)
  pvalue[sim] <- Q$pvalue
  nItems[sim] <- Q$items
}
mean10 <- mean(nItems)
power10 <- sum(pvalue <= 0.05)/50000
